## This package accepts the following switches:
##   --with spf    ...  enable SPF support

%define username	grmilter
%define vardir		%{_var}/lib/%{name}
%define dbdir		%{vardir}/db
%define rundir		%{vardir}/run
%define piddir		%{_var}/run/milter-greylist
%define __chkconfig	/sbin/chkconfig

Summary:	A milter for greylisting, the Next Step in the Spam Control War 
Name:		milter-greylist
Version:	1.4
Release:	1
Epoch:		0
License:	BSD w/ advertising
Group:		System Environment/Daemons
URL:		http://hcpnet.free.fr/milter-greylist/
Source0:	ftp://ftp.espci.fr/pub/milter-greylist/%{name}-%{version}.tgz
Patch0:		milter-greylist-1.2.1-rh.patch
Patch1:		milter-greylist-1.3.9-user.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
PreReq:		initscripts
PreReq:		chkconfig
PreReq:		shadow-utils
BuildRequires:	bison flex m4
BuildRequires:	sendmail-devel %{?_with_spf:libspf-devel}

%description
Greylisting is a new method of blocking significant amounts of spam at
the mailserver level, but without resorting to heavyweight statistical
analysis or other heuristical (and error-prone) approaches. Consequently,
implementations are fairly lightweight, and may even decrease network
traffic and processor load on your mailserver.

This package provides a greylist filter for sendmail's milter API.


%prep
%setup -q
%patch0 -p1 -b .rh
#%patch1 -p1 -b .user


perl -pi -e 's!(\$\{INSTALL\}.*\s)(\S+\s*)$!$1\${DESTDIR}$2!' Makefile.in
perl -pi -e 's!--rpath!--XXXX!g' configure

for i in `find -type f`; do
    sed -e 's!/var/milter-greylist/milter-greylist.sock!%{rundir}/milter-greylist.sock!g;
            s!/var/milter-greylist/greylist.db!%{dbdir}/greylist.db!g;
	    s!/var/run!%{piddir}!g;
	    s!@XXUSER@!%{username}!g;
	   ' "$i" >"$i.tmp"
    cmp -s "$i" "$i.tmp" || cat "$i.tmp" >"$i"
    rm -f "$i".tmp
done


%define makeflags	USER="$(id -u)" TEST=false BINDIR=%_sbindir
%build
## Follow timeout-recommendations at http://projects.puremagic.com/greylisting/
%configure \
	--with-user=%{username} \
	%{?_with_spf:--with-libspf=/usr}

## is not SMP safe :(
%__make %makeflags


%install
rm -rf $RPM_BUILD_ROOT
%{__install} -d -m755 \
	$RPM_BUILD_ROOT{%{_sysconfdir}/mail,%{rundir},%{dbdir},%{_initrddir},%{piddir}}

%{__make} DESTDIR=$RPM_BUILD_ROOT install %makeflags
%{__install} -p -m755 rc-linux.sh $RPM_BUILD_ROOT%{_initrddir}/%{name}

# create temporary files
touch $RPM_BUILD_ROOT%{rundir}/milter-greylist.sock
touch $RPM_BUILD_ROOT%{piddir}/milter-greylist.pid


%pre
%{_sbindir}/groupadd -g 17 -r %{username} &>/dev/null || :
%{_sbindir}/useradd -u 17 -r -s /sbin/nologin -M -d %{vardir} \
                            -c 'Greylist-milter user' -g %{username} %{username} &>/dev/null || :

%post
%{__chkconfig} --add %{name}

%preun
test "$1" != 0 || %{__chkconfig} --del %{name}
test "$1" != 0 || %{_initrddir}/%{name} stop >/dev/null || :

%postun 
test "$1" != 0 || %{_sbindir}/userdel  %{username} &>/dev/null || :
test "$1" != 0 || %{_sbindir}/groupdel %{username} &>/dev/null || :
test "$1"  = 0 || %{_initrddir}/%{name} condrestart >/dev/null || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc ChangeLog README
%{_mandir}/man*/*
%attr(0640,root,%{username}) %config(noreplace) %{_sysconfdir}/mail/greylist.conf
%dir %attr(0751,%{username},%{username}) %{vardir}
%dir %attr(0770,%{username},%{username}) %{dbdir}
%dir %attr(0700,%{username},root) %{rundir}
%dir %attr(0775,root,%{username}) %{piddir}
%_sbindir/*

%ghost %{rundir}/milter-greylist.sock
%ghost %{piddir}/milter-greylist.pid

%config %{_initrddir}/*

%changelog
* Thu Oct 21 2004 Peter Hanecak <hanecak@megaloman.com> 0:1.4-1
- adapted to Doors Linux

* Tue Jun 15 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:1.4-0.fdr.1
- updated to 1.4

* Fri Jun 11 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:1.3.9-0.fdr.1
- updated to 1.3.9

* Thu Apr 29 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:1.2.1-1
- Initial build.
